unit MidPoint_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TControlPanel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    procedure MovingOfMidpoint(Sender: TObject);
    procedure Finish(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  ControlPanel: TControlPanel;

implementation

{$R *.DFM}

procedure TControlPanel.MovingOfMidpoint(Sender: TObject);
Type TPixel =  Array [1..2] of Integer;
var A,B :  TPixel;

  Procedure Moving(A,B:TPixel;Level:Byte);
  var S:TPixel;
  begin
    if Level=0 then
        begin
          Image1.Canvas.MoveTo(A[1],A[2]);
          Image1.Canvas.LineTo(B[1],B[2]);
          exit;
        end
    else begin
    Level:=Level-1;
    S[1]:=Round((A[1]+B[1])/2);
    S[2]:=Round((A[2]+B[2])/2+(B[1]-A[1])*(Random-0.5)/2);
    Moving(A,S,Level);
    Moving(S,B,Level);
    end;
  end;

begin
   A[1]:=0;A[2]:=100;
   B[1]:=ClientWidth-1;B[2]:=200;
   Moving(A,B,4);
end;

procedure TControlPanel.Finish(Sender: TObject);
begin
  Application.Terminate;
end;

end.
