unit Usp_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls;

type
  TSeznam = array [0..50] of string;
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button2: TButton;
    Button1: TButton;
    Button4: TButton;
    EditTimeBuble: TEdit;
    StaticText1: TStaticText;
    EditMsBuble: TEdit;
    StaticText3: TStaticText;
    StaticText2: TStaticText;
    EditTimeQuick: TEdit;
    EditMSQuick: TEdit;
    StaticText4: TStaticText;
    procedure BublinovaMetoda(Sender: TObject);
    procedure Generovani(Sender: TObject);
    procedure QuickSort(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Const Pocet = 10000;
var
  Form1: TForm1;
  Prvek,Buble,Quick:Array [1..Pocet] of Integer;
  PrevodRetezec:String;

implementation

{$R *.DFM}

procedure TForm1.BublinovaMetoda(Sender: TObject);
var i,Trezor :Integer;
    Zmena:Boolean;
    t1,t2:Real;
    PrevodRetezec :String;
begin
  t1:=Time;
  Repeat
    Zmena:=False;
    For i:=1 to Pocet-1 do
       if Buble[i]>Buble[succ(i)] then
       begin
         Trezor:=Buble[i];
         Buble[i]:=Buble[Succ(i)];
         Buble[Succ(i)]:=Trezor;
         zmena:=True;
       end;
  until not Zmena;
  t2:=Time;
  For i:=1 to Pocet do
  begin
     Str(Buble[i],PrevodRetezec);
     StringGrid1.Cells[2,i-1]:=PrevodRetezec;
  end;
  EditTimeBuble.Text:=TimeToStr(t2-t1);
  Str(Trunc((t2-t1)/1.1574e-8),PrevodRetezec);
  EditMsBuble.Text:=PrevodRetezec;
end;

procedure TForm1.Generovani(Sender: TObject);
var i            :Integer;
begin
  For i:=1 to Pocet do
  begin
    Prvek[i]:=Trunc(Random*90000+10000);
    StringGrid1.Cells[0,i-1]:=IntToStr(i);
    StringGrid1.Cells[1,i-1]:=IntToStr(Prvek[i]);
  end;
  Buble:=Prvek;Quick:=Prvek;
end;

procedure TForm1.QuickSort(Sender: TObject);
var i            :Integer;
    t1,t2        :Real;

   procedure sort(levy,pravy:integer);
   var pivot,i,j,Trezor: integer;
   begin
     i:=levy;j:=pravy;
     pivot:=Quick[(levy+pravy) div 2];
     repeat
     while Quick[i]<pivot do inc(i);
     while Quick[j]>pivot do dec(j);
     if i<=j then
              begin
                Trezor:=Quick[i];Quick[i]:=Quick[j];Quick[j]:=Trezor;
                inc(i);dec(j);
              end;
   until i>j;
   if levy<j then sort(levy,j);
   if pravy>i then sort(i,pravy);
   end;

begin
  t1:=Time;
  Sort(1,Pocet);
  t2:=Time;
  For i:=1 to Pocet do
  begin
     Str(Quick[i],PrevodRetezec);
     StringGrid1.Cells[3,i-1]:=PrevodRetezec;
  end;
  EditTimeQuick.Text:=TimeToStr(t2-t1);
  EditMsQuick.Text:=inttoStr(Trunc((t2-t1)/1.1574e-8));
end;

end.
