unit SemVypln;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    procedure Clear(Sender: TObject);
    procedure Draw(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  obr  :Array [0..1000,0..1000] of byte;
  Point:Array [1..2] of Integer;
  Citac:Integer;

implementation

{$R *.DFM}

Function SetColor(Red,Green,Blue:Byte):DWord;
begin
  SetColor:=Red+256*Green+256*256*Blue;
end;

procedure TForm1.Clear(Sender: TObject);
var i,j  :Integer;
    Color:Word;
begin
 With Image1 do
  begin
  Canvas.Pen.Color:=clWhite;
  Canvas.Brush.Color:=clWhite;
  Canvas.Rectangle(0,0,Width-1,Height-1);
  For i:=0 to Width do
      For j:=0 to Height do Obr[i,j]:=255;
  Canvas.Pen.Color:=clBlack;
  end;
  Citac:=0;
end;

procedure TForm1.Draw(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Pocet,i,j:LongInt;
    Vypis    :String;

procedure Seed_Fill (x, y:Integer; vypln, hranice: Byte);
  var aktual: Byte;
      Color:DWord;
  begin
    Color:=SetColor(vypln,vypln,vypln);
    aktual := Obr[x,y];
    if (aktual <> hranice) and
       (aktual <> vypln) and
       (x>=0) and (y>=0) and
        (x<Image1.Width) and (y<Image1.Height) then
        begin
          Obr[x,y]:=vypln;
          Image1.Canvas.Pixels[x,y]:=Color;
          Pocet:=Succ(Pocet);
          if Pocet mod 1000 = 0 then Image1.Repaint;
          Seed_Fill (x + 1, y, vypln, hranice);
          Seed_Fill (x - 1, y, vypln, hranice);
          Seed_Fill (x, y + 1, vypln, hranice);
          Seed_Fill (x, y - 1, vypln, hranice);
        end
  end; {Seed_Fill}

begin
 if Button=mbLeft then
  begin
    With Image1.Canvas do
       if Citac=0
        then begin MoveTo(x,y);Pixels[x,y]:=0;end
        else LineTo(x,y);
    Citac:=succ(Citac);
  end;
 if Button=mbRight then
  begin
    With Image1 do
     For i:=0 to Width do
      For j:=0 to Height do
             if Canvas.Pixels[i,j]=0 then Obr[i,j]:=0;
    Pocet:=0;Citac:=0;
    Seed_Fill(x,y,150,0);
    Str(Pocet,Vypis);
    Image1.Canvas.TextOut(x,y,Vypis);
  end;
end;

end.
